import { OnListenerBySelector } from './event';
import { HubBindings } from './hub';
export declare abstract class BaseHTMLElement extends HTMLElement {
    readonly uid: string;
    protected readonly _nsObj: {
        ns: string;
    };
    events?: OnListenerBySelector;
    docEvents?: OnListenerBySelector;
    winEvents?: OnListenerBySelector;
    hubEvents?: HubBindings;
    preDisplay?(): void;
    postDisplay?(): void;
    private _init;
    protected get initialized(): boolean;
    constructor();
    init(): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    attributeChangedCallback(attrName: string, oldVal: any, newVal: any): void;
}
export declare function addDOMEvents(target: OnListenerBySelector | undefined, source: OnListenerBySelector): OnListenerBySelector;
export declare function addHubEvents(target: HubBindings | undefined, source: HubBindings): (import("./hub").HubListenerByFullSelector | import("./hub").HubListenerByHubNameBySelector)[];
